<?php
namespace Manager;
use Manager\IGenericDataManager;
use Service\IAuthService;
use Utils\Validation;
// c'est le modéle
class UserManager {
    private IAuthService $authService;
    public function __construct(IAuthService $authService){}

    public function login($loginUser,$passwordUser): bool{
        if(!Validation::val_string($passwordUser) || !Validation::val_string($loginUser)) throw new \Exception(" some wrong with cred !!!!!");
        if($this->authService->login($loginUser,$passwordUser)){
            return true;
        }
        return false;
    }

    public function resgister($loginUser,$passwordUser): bool{
        if(!Validation::val_string($passwordUser) || !Validation::val_string($loginUser)) throw new \Exception(" some wrong with cred !!!!!");
        if($this->authService->register($loginUser,$passwordUser)){
            return true;
        }
        return false;
    }

    public function deconnecter():bool{
        try {
            $this->authService->logoutUser();
            return true;
        } catch (\Exception $e) {
            return false;
        }
       
    }
}


?>