<?php
namespace Model;

interface IGenericRepository
{
    public function getItemById();
    public function GetNbItems(): int;
    public function GetItems(int $index, int $count, ?string $orderingPropertyName = null, bool $descending = false): array;
    public function GetItemsByName(string $substring, int $index, int $count, ?string $orderingPropertyName = null, bool $descending = false): array;
    public function GetItemByName(string $substring, int $index, int $count, ?string $orderingPropertyName = null, bool $descending = false): array;
    public function UpdateItem($oldItem, $newItem);
    public function AddItem($item);
    public function DeleteItem($item): bool;
}

?>